/*  zweic -- a compiler for Zwei
 *
 *  Stephane Micheloud & LAMP
 *
 *  $Id: Visitor.java 2146 2005-11-13 17:39:11 +0100 (Sun, 13 Nov 2005) michelou $
 */

package zweic;

import zweic.Tree.*;


/** The visitor interface.
 */
interface Visitor {
    void caseBad(Bad tree);

    void caseProgram(Program tree);
    void caseClassDef(ClassDef tree);
    void caseFieldDecl(FieldDecl tree);
    void caseMethodDef(MethodDef tree);

    void caseIntType(IntType tree);
    void caseNullType(NullType tree);
    void caseClassType(ClassType tree);

    void caseWhile(While tree);
    void caseVar(Var tree);
    void caseSet(Set tree);
    void caseDo(Do tree);

    void caseIf(If tree);
    // ...  complter ...
}
